require("fighter")

local lg = love.graphics
local la = love.audio
local lt = love.timer

local tracks = {}
local curTrack = 1
local paused = false

local function nextTrack()
    la.stop(tracks[curTrack])
    if curTrack + 1 > #tracks then
        curTrack = 1
    else
        curTrack = curTrack + 1
    end
    la.play(tracks[curTrack])
end

function love.load()
    Player1 = Fighter:new({
        name = "Bacon",
        player = "one",
        x = 256,
        y = 256,
        dir = -1,
        state = "stance"})
    Player1:load("images/Bacon/")
    Player1.curAnim = Player1.moves.general.stance
    Player2 = Fighter:new({
        name = "Pythagoras",
        player = "two",
        x = 512,
        y = 256,
        dir = 1,
        state = "stance"})
    Player2:load("images/Pythagoras/")
    Player2.curAnim = Player2.moves.general.stance
    tracks = {la.newSource("music/Fight1.mp3"), la.newSource("music/Fight2.mp3")}
    la.play(tracks[curTrack])
    --la.pause(tracks[curTrack])
    lg.setBackgroundColor(150, 150, 150)
end

function love.keypressed(key, unicode)
    if key == "a" or key == "s" or key == "d" or key == "q" or key == "w" or key == "e" then
        Player1:keypressed(key)
    end
    if key == "kp4" or key == "kp5" or key == "kp6" or key == "kp7" or key == "kp8" or key == "kp9" then
        Player2:keypressed(key)
    end
    if key == "escape" then
        love.event.push("quit")
    elseif key == "m" then
        if paused == true then
            la.resume(tracks[curTrack])
            paused = false
        else
            la.pause(tracks[curTrack])
            paused = true
        end
    elseif key == "n" then
        nextTrack()
    elseif key == "h" then
        Player1.health = 100
        Player2.health = 100
    end
end

local cd = 2
local garb = 0
function love.update(dt)
    cd = cd - dt
    if cd <= 0 then
        garb = collectgarbage("count")*1024
        garb = garb .. "MB"
        cd = 2
    end
    if tracks[curTrack]:isStopped() then
        nextTrack()
    end
    Player1:update(dt, Player2)
    Player2:update(dt, Player1)
end

function love.draw()
    lg.print(table.concat(Player1.keys, ","), 100, 0)
    --lg.print(Player1.keyDelay, 180, 0)
    love.graphics.print("FPS: " .. tostring(lt.getFPS( )), 512, 0)
    love.graphics.print(garb, 320, 0)
    Player1:draw()
    Player2:draw()
end
